--
-- ### Cast handling for default and insert values
--

drop if exists table t1;
drop if exists table t2;
drop if exists table t3;
drop if exists table t4;
drop if exists table t5;
drop if exists table t6;
drop if exists table t7;


create table t1 ( a int, b fixed(2) default 3.257867 not null);
desc table t1;
insert into t1 ( a ) values ( 3 );
select * from t1;

create table t2 ( a int, b fixed(2) default 56 not null);
desc table t2;

insert into t2 ( a ) values ( 1 );
insert into t2 ( a, b ) values ( 2, (fixed)44.98 );
insert into t2 ( a, b ) values ( 3, 44 );

create table t3 ( a int, b float default 7.99 not null);
desc table t3;

insert into t3 ( a ) values ( 1 );
insert into t3 ( a, b ) values ( 2, 44.98 );
insert into t3 ( a, b ) values ( 3, 44 );


create table t4 ( a string(30));

-- check cast from datetime to varchar
insert into t4 values ( sysdate );
-- check cast from decimal to varchar
insert into t4 values ( (decimal)34.789 );
select * from t4;

-- check cast from decimal to fixed
create table t5 ( a fixed(2) );
insert into t5 values ( (decimal)6.18123 );
-- insert into t5 values ( (fixed)6.98 );
select * from t5;

create table t6 ( a decimal(20) );
-- check cast from float to decimal
insert into t6 values ( 46754.76567 );
select * from t6;

create table t7 ( a bigint(20) );
-- check cast from long to bigint
insert into t7 values ( (long)463475476567 );
select * from t7;
